#pragma once

#include <memory>
#include <string>

class AudioDevice
{

private:

    std::string mName;
    unsigned mSampleRate;
    unsigned mNumChannels;
    unsigned mPeriod;
    std::size_t mBufferSize;

public:

    AudioDevice();

    ~AudioDevice();

    void SetSampleRate(unsigned rate);

    unsigned GetSampleRate() const;

    void SetName(const std::string& name);

    void SetNumChannels(unsigned numChannels);

    void SetPeriod(unsigned period);

    void SetBufferSize(std::size_t bufferSize);

    unsigned GetNumChannels() const;

    unsigned GetPeriod() const;

    std::size_t GetBufferSize() const;

    std::string GetName() const;

    static std::unique_ptr<AudioDevice> Create();
};

using AudioDevicePtr = std::unique_ptr<AudioDevice>;
