#include "AudioManager.h"
#include "AlsaInterface.h"

AudioManager::AudioManager()
    : mAudioDevices(),
      mAudioInterface()
{
    mAudioInterface = AlsaInterface::Create();
}

AudioManager::~AudioManager()
{

}

std::unique_ptr<AudioManager> AudioManager::Create()
{
    return std::make_unique<AudioManager>();
}

void AudioManager::AddAudioDevice(AudioDevicePtr device)
{
    mAudioDevices.push_back(device);
}

IAudioInterface* AudioManager::GetAudioInterface()
{
    return mAudioInterface.get();
}

std::vector<AudioDevicePtr> AudioManager::GetAudioDevices()
{
    return mAudioDevices;
}
